[WIP]

Developer workflow
------------------

I'll start by listing scheduled (current + backlog) stories:

    $ flux pt
    ID        STATE      ASSIGNEE    EST  STORY
    12345679  finished   David Leal    1  A developer can link a branch to a story
    12345680  finished   David Leal    1  A developer can mark a story as started
    12345678  unstarted                   A developer can grab a story
    ...

`12345678` is next in line, so I'll just pick that one:

    $ flux feature:start 12345678 dl/grab_a_story -e 1

This does a few things:

* Assigns `12345678` to me.
* Sets `1` as `12345678`'s estimate (you can't start a story unless it's estimated).
* Marks `12345678` as `started`.
* Creates dl/grab_a_story and origin/dl/grab_a_story.
* Sets origin/dl/grab_a_story as dl/grab_a_story's upstream.

[Time passes.]

I'm done with the feature, so I'll push it and ask for a review [TODO: automate this]

    $ git push
    $ flux review:request

Reviewer workflow
-----------------

Studies have found that, to properly review code, you need to look at small
changes at a time. This allows you to reason about each change, and
increases your chances of finding bugs. However, Github pull requests
encourage you to look at changes as a whole. If you add a comment to a
commit and then rewrite the branch, the comment will be wiped out from the
pull request view.

To work around this, we create a new pull request whenever we need to review
changes to a branch.

The first time we get a pull request, we just review it on Github. We add
comments to each commit, and leave the pull request open.

The branch owner sees the comments, makes the necessary changes, force-pushes
the branch again and asks for a new review, using

    $ flux review:request

This will close the old pull request and open a new one.

The reviewer can check if a new branch was changed using

    $ flux review:history <branch name>
    NUM     STORY  AUTHOR  DATE              TITLE
     34  19692783  david   2012-02-21 15:15  A developer can only submit for...
     33  19692783  david   2012-02-21 13:02  A developer can only submit for...

The reviewer can also see what exactly changed between the 2 branches using

    $ flux review:diff
    ...

Without arguments, this will show an interdiff between the last 2 revisions.
